
function on_move( vot )
{
	// dijkstra
	var G = world.graph
	var path = dijkstra( G, self.pos, self.veh(),
				function(n){return world.bank[n] == 0} )
	if( path )
		self.pos = path[0]
	else { // otherwise random
		var edge = G[self.pos][self.veh()]
		self.pos = edge[rand(edge.length)]
	}
}

//===========================================================================
// Simplest cop. They just hurry to the bank with no money.
// If no such bank exists, then randomly moves.
//===========================================================================
loadClass("core")
COP( "NaNaIRo_copA_" )
