
function dij_go(copname, goal)
{
	for each(var cop in world.cop)
		if(cop.name == copname) {
			var path = dijkstra(
				world.graph, cop.pos, "car", function(n){return n==goal} )
			return [cop.name, (path?path[0]:cop.pos), "cop-car", world.serial+1]
		}
}


var state1 = function()
{
	var m0target = "57-and-woodlawn"
	var m1target = "55-and-woodlawn"
	if( "rob" in world ) {
		if( world.rob.pos=="58-culdesac" ) {
			on_plan = state2
			return on_plan()
		} else if( world.rob.pos=="57-and-kimbark" ) {
			m0target = "57-and-kimbark"
		} else if( world.rob.pos=="53-and-woodlawn" ) {
			m1target = "53-and-woodlawn"
		}
	}

	var m0 = dij_go(world.name.cop[0],m0target)
	var m1 = dij_go(world.name.cop[1],m1target)
	self.pos = m0[1]
	return [ m0, m1,
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var state2 = function()
{
	on_plan = state3

	var m0 = dij_go(world.name.cop[0],"57-and-cottage-grove")
	var m1 = dij_go(world.name.cop[1],"55-and-cottage-grove")
	self.pos = m0[1]
	return [ m0, m1,
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var state3 = function()
{
	on_plan = state4

	var m0 = dij_go(world.name.cop[0],"57-and-maryland")
	var m1 = dij_go(world.name.cop[1],"57-and-cottage-grove")
	self.pos = m0[1]
	return [ m0, m1,
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var two_cand = ["57-and-drexel", "58-and-maryland"]
var state4 = function()
{
	var m0
	if( "smell" in world ) {
		on_plan = state1
		if(two_cand.length==0) two_cand = ["57-and-drexel", "58-and-maryland"]
		var i = rand(two_cand.length)
		m0 = dij_go(world.name.cop[0],(i==0?two_cand.pop():two_cand.shift()))
	} else {
		on_plan = state5
		m0 = dij_go(world.name.cop[0],"57-and-maryland")
	}

	var m1 = dij_go(world.name.cop[1],"58-and-cottage-grove")
	self.pos = m0[1]
	return [ m0, m1,
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var state5 = function()
{
	on_plan = state6

	var m0 = dij_go(world.name.cop[0],"57-and-drexel")
	var m1 = dij_go(world.name.cop[1],"58-and-maryland")
	self.pos = m0[1]
	return [ m0, m1,
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var state6 = function()
{
	on_plan = state7

	var m0 = dij_go(world.name.cop[0],"58-and-drexel")
	self.pos = m0[1]
	return [ m0,
	         dij_go(world.name.cop[1],"55-and-woodlawn"),
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var state7 = function()
{
	on_plan = state1

	var m0 = dij_go(world.name.cop[0],"58-culdesac")
	self.pos = m0[1]
	return [ m0,
	         dij_go(world.name.cop[1],"55-and-woodlawn"),
	         dij_go(world.name.cop[2],"53-and-the-other-lake-park"),
	         dij_go(world.name.cop[3],"55-and-harper"), 
	         dij_go(world.name.cop[4],"60-and-blackstone") ]
}

var on_plan = state1

//===========================================================================
// entirely depends on the first map given.
//===========================================================================
loadClass("core")
COP( "NaNaIRo_copZ_", "cop-car" )
