
//----------------------------------------------------------
// dbg()
//   print debug strings to standard error output
//----------------------------------------------------------

function dbg(str)
{
	java.lang.System.err.println( "## "+str )
}

//----------------------------------------------------------
// Prototyped
//   constructor for prototype chaining
//----------------------------------------------------------

function Prototyped(obj)
{
	this.__proto__ = obj
}

//----------------------------------------------------------
// rand(n)
//   return a random integer in [0 .. n)
//----------------------------------------------------------

function rand(n)
{
	return Math.floor(Math.random() * n)
}

//----------------------------------------------------------
// cointoss(p)
//   true in probability p, false in (1-p)
//----------------------------------------------------------

function cointoss(p)
{
	return p < Math.random();
}

//----------------------------------------------------------
// z(x)
//   evaluates x to a number. if undefined then 0.
//----------------------------------------------------------

function z(x)
{
	return x ? x : 0
}

//----------------------------------------------------------
// sizeof(x)
//----------------------------------------------------------

function sizeof(x)
{
	var c = 0
	for( var _ in x )
		++c
	return c
}
