loadClass("cop_common")
vote_me = true

//------------------------------------------------------------
// plannings
//------------------------------------------------------------

var prevpos = {}

function on_my_plan( pcloud, possibleNodes )
{
	var ans = []
	for each(var oneself in world.cop)
	{
		var Num  = (possibleNodes.length>5 ? 5 :possibleNodes.length)
		var goal = possibleNodes[rand(Num)]
		var P    = oneself.pos
		var VEH  = oneself.veh()
		var NAME = oneself.name

		if( P==world.hq )
		   VEH = (cointoss(0.6) ? "foot" : "car")

		var nearMe = {} ; nearMe[P] = 1
        for each(var pt in world.graph[P][VEH])
		    nearMe[pt] = 1
		var copzone = {}
		for each(var cp in world.cop) {
		    if( cp.name == NAME ) continue
			copzone[cp.pos] = (cp.pos in nearMe ? 999999 : 999)
			for each(var pt in world.graph[cp.pos][cp.veh()])
				if( pt in world.bank )
					copzone[pt] = (pt in nearMe ? 2 : 0)
				else
				    copzone[pt] = (pt in nearMe ? 2 : 0)
		}

		// dijkstra
		var G = world.graph
		var path = dijkstra( G, P, VEH,
			function(n){return n==goal},
			function(n){return (n==prevpos[NAME]?100:0)+z(copzone[n])} )

		if( path )
			P = path[0]
		else {
			var edge = G[P][VEH]
			var P    = edge[rand(edge.length)]
		}
		ans.push( [NAME, P, "cop-"+VEH, world.serial+1] )
		prevpos[NAME] = oneself.pos
	}
	return ans
}


//===========================================================================
// a little bit modified version of copC
//===========================================================================
loadClass("core")
COP( "NaNaIRo_copD_" )
