
var copness = {}
var degree  = {}
var prevpos

function on_init()
{
	for(var n in world.graph)
        switch(world.graph[n].foot.length)
		{
        case 1: degree[n] = 20; break
		case 2: degree[n] =  5; break
		}
}

function on_move()
{
	var nearMe = {} ; nearMe[self.pos] = 1
	for each(var pt in world.graph[self.pos][self.veh()])
		nearMe[pt] = 1

	var copzone = {}
	for each(var cp in world.cop) {
		copness[cp.pos] += 2
		copzone[cp.pos] = (cp.pos in nearMe ? 999999 : 500)
		if( cp.pos == world.hq )
			for(var veh in world.graph[cp.pos])
			for each(var pt in world.graph[cp.pos][veh] )
				if( pt in world.bank )
					copzone[pt] = (pt in nearMe ? 600 : 100)
				else
					copzone[pt] = (pt in nearMe ? 600 : 10)
		else
			for each(var pt in world.graph[cp.pos][cp.veh()])
				if( pt in world.bank )
					copzone[pt] = (pt in nearMe ? 600 : 100)
				else
					copzone[pt] = (pt in nearMe ? 600 : 10)
	}

	var path = dijkstra( world.graph, self.pos, self.veh(),
			             function(n){return world.bank[n] > 0},
						 function(n){return (n==prevpos?400:0)+z(copness[n])+z(degree[n])+z(copzone[n])} )
	if( path )
		if( z(copzone[path[0]])<500 || z(copzone[self.pos])>500 )
		{
			prevpos  = self.pos
			self.pos = path[0]
		}
}


//===========================================================================
// This robber hurries to the nearest bank everytime, avoiding
// the cops and go-back to the previous position he was.
//===========================================================================
loadClass("core")
ROBBER( "NaNaIRo_robA_" )
